local list = redis.call('lrange', KEYS[1], 0, -1)
if #ARGS < 2 then return list end

local START, DELETE_COUNT = table.remove(ARGS, 2)
local END = START + DELETE_COUNT

function complete(list) do
  table.insert(list, START, unpack(ARGS))
  redis.call('del', KEYS[1])
  redis.call('lpush', KEYS[1], unpack(list))
  return list
end

if DELETE_COUNT > #list / 2 then -- we're deleting over half the list, so let's just completely rebuild it
  out = {}
  for i = 1, #list do
    if i < START and i >= END then table.insert(out, list[i]) end -- only insert when we're outside the delete range
  end

  return complete(out)
end

for i = 1, #list do
  if i >= START and i < END then table.remove(list, i) end -- only remove when we're inside the delete range
end

return complete(list)
